// Variablen
int dinoPosX, dinoPosY;
int dinoVelY;
boolean dinoJump;

int[] kaktusPosX = new int[4];
int[] kaktusPosY = new int[4];

int counter;
int highscore;
int level;

boolean gameStarted;

// Variablen für Bilder hinzufügen
PImage dinoImage;
PImage kaktusImage;
PImage hintergrundImage;

// Setup
void setup() {
  size(900, 400);
  frameRate(80);
  background(238,216,174);
 
  // Bilder laden und skalieren
  dinoImage = loadImage("dino.png");
  dinoImage.resize(60, 60);
  
  kaktusImage = loadImage("kaktus.png");
  kaktusImage.resize(30, 50);
  
  hintergrundImage=loadImage ("hintergrund.jpg");
  hintergrundImage.resize(900, 400);

  dinoPosX = 40;
  dinoPosY = height - dinoImage.height;

  for (int i = 0; i < kaktusPosX.length; i++) {
    kaktusPosX[i] = width + i * int(random(100, 200));
    kaktusPosY[i] = height - kaktusImage.height;
  }

  dinoVelY = 0;
  dinoJump = false;

  counter = 0;
  highscore = 0;
  level = 1;

  gameStarted = false;
}

// Update-Funktion
void update() {
  dinoVelY += 1;

  if (dinoJump) {
    dinoVelY = -16;
    dinoJump = false;
  }

  dinoPosY += dinoVelY;

  if (dinoPosY >= height - dinoImage.height) {
    dinoPosY = height - dinoImage.height;
    dinoVelY = 0;
  }

  for (int i = 0; i < kaktusPosX.length; i++) {
    kaktusPosX[i] -= 5 + (level - 1);
    if (kaktusPosX[i] < -kaktusImage.width) {
      kaktusPosX[i] = width + int(random(200, 300));
      kaktusPosY[i] = height - kaktusImage.height;
    }
  }

    // Kollisionskontrolle
  boolean collision = false;
  for (int i = 0; i < kaktusPosX.length; i++) {
    if (dinoPosX + dinoImage.width > kaktusPosX[i] && dinoPosX < kaktusPosX[i] + kaktusImage.width && dinoPosY + dinoImage.height > kaktusPosY[i]) {
      collision = true;
      break;
    }
  }

  if (collision) {
    counter = 0;
    for (int i = 0; i < kaktusPosX.length; i++) {
      kaktusPosX[i] = width + i * int(random(200, 300));
      kaktusPosY[i] = height - kaktusImage.height;
    }
    gameStarted = false;
    level = 1;
  } else if (counter > highscore) {
    highscore = counter;
  }
}

// Design-Funktion
void drawDesign() {
  background(hintergrundImage);
  image(dinoImage, dinoPosX, dinoPosY);

  for (int i = 0; i < kaktusPosX.length; i++) {
    image(kaktusImage, kaktusPosX[i], kaktusPosY[i]);
  }

  fill(0);
  text("Counter: " + counter, 80, 20);
  text("Highscore: " + highscore, 80, 40);
  text("Level: " + level, 80, 60);
}

// Draw-Funktion
void draw() {
  if (gameStarted) {
    update();
    drawDesign();

    if (counter % 2000 == 0 && counter != 0) {
      level++;
    }
    counter++;
  } else {
    background(238,216,174);
    fill(0);
    textAlign(CENTER, CENTER);
    fill(74,112,139);
    textSize(45);
    text("DINO CRASHER", width / 2, 100);
    textSize(24);
    text("Spring mit Hilfe der Space-Taste über die Asteroiden", width / 2, height / 2);
    
    //Startknopf
    fill(193,205,193);
    noStroke();
    rect(300, 250, 300, 100);
    fill(74,112,139);
    textAlign(CENTER);
    textSize(24);
    text("Zum Starten", width / 2, 285);
    text("Space-Taste Drücken", width / 2, 325);
    
  }
}


// Tastendruck-Funktion
void keyPressed() {
  if (key == ' ' && !dinoJump && gameStarted) {
    dinoJump = true;
  }
  if (key == ' ' && !gameStarted) {
    gameStarted = true;
  }
}
